---
title: Callgraph Services
author:
date: 2024-06-06
...

# Callgraph Services {#callgraph-services}

## plugins.callgraph.vertex (`DATA`) {#vertex}

> [`vertex`](#vertex)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"name"` | _string_ | The function name of the node |
| `"decl"` | [`decl`](../../kernel/ast.md#decl)  | The declaration tag of the function |
| `"is_root"` | _boolean_ | whether this node is the root of a service |
| `"root"` | [`decl`](../../kernel/ast.md#decl)  | the root of this node's service |


## plugins.callgraph.edgeKind (`DATA`) {#edgekind}

Whether the call goes through services or not


> [`edgeKind`](#edgekind)  `::=` _tags…_
  

| Tags | Value | Description |
|:-----|:------|:------------|
| Inter_services | `"inter_services"` | a call between two services |
| Inter_functions | `"inter_functions"` | a call inside a service |
| Both | `"both"` | both cases above |


## plugins.callgraph.edgeKindTags (`GET`) {#edgekindtags}

Registered tags for the above type.


> _input_ `::=` _null_
  

> _output_ `::=` [`tag`](../../kernel/data.md#tag)  `[]`
  

## plugins.callgraph.edge (`DATA`) {#edge}

> [`edge`](#edge)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"src"` | [`decl`](../../kernel/ast.md#decl)  | src |
| `"dst"` | [`decl`](../../kernel/ast.md#decl)  | dst |
| `"kind"` | [`edgeKind`](index.md#edgekind)  | kind |


## plugins.callgraph.graph (`DATA`) {#graph}

The callgraph of the current project


> [`graph`](#graph)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"vertices"` | [`vertex`](index.md#vertex)  `[]` | vertices |
| `"edges"` | [`edge`](index.md#edge)  `[]` | edges |


## plugins.callgraph.callgraph (`STATE`) {#callgraph}

The current callgraph or an empty graph if it has not been computed yet


## plugins.callgraph.signalCallgraph (`SIGNAL`) {#signalcallgraph}

Signal for state [`callgraph`](#callgraph) 


## plugins.callgraph.getCallgraph (`GET`) {#getcallgraph}

Getter for state [`callgraph`](#callgraph) 


> _input_ `::=` _null_
  

> _output_ `::=` [`graph`](index.md#graph)  `?`
  

## plugins.callgraph.isComputed (`STATE`) {#iscomputed}

This boolean is true if the graph has been computed


## plugins.callgraph.signalIsComputed (`SIGNAL`) {#signaliscomputed}

Signal for state [`isComputed`](#iscomputed) 


## plugins.callgraph.getIsComputed (`GET`) {#getiscomputed}

Getter for state [`isComputed`](#iscomputed) 


> _input_ `::=` _null_
  

> _output_ `::=` _boolean_
  

## plugins.callgraph.compute (`EXEC`) {#compute}

Compute the callgraph for the current project


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  