---
title: Eva Values
author:
date: 2024-06-06
...

# Eva Values {#eva-values}

## plugins.eva.values.changed (`SIGNAL`) {#changed}

Emitted when EVA results has changed


## plugins.eva.values.callstack (`DATA`) {#callstack}

Callstack identifier


> [`callstack`](#callstack)  `::=` `#callstack`
  

## plugins.eva.values.callsite (`DATA`) {#callsite}

Call site infos


> [`callsite`](#callsite)  `::=` `{` `"callee"` `:`
  [`decl`](../../kernel/ast.md#decl)  , `"caller"` `:?`
  [`decl`](../../kernel/ast.md#decl)  , `"stmt"` `:?`
  [`marker`](../../kernel/ast.md#marker)  , `"rank"` `:?` _number_ `}`
  

## plugins.eva.values.getCallstacks (`GET`) {#getcallstacks}

Callstacks for markers


> _input_ `::=` [`marker`](../../kernel/ast.md#marker)  `[]`
  

> _output_ `::=` [`callstack`](values.md#callstack)  `[]`
  

## plugins.eva.values.getCallstackInfo (`GET`) {#getcallstackinfo}

Callstack Description


> _input_ `::=` [`callstack`](values.md#callstack) 
  

> _output_ `::=` [`callsite`](values.md#callsite)  `[]`
  

## plugins.eva.values.getStmtInfo (`GET`) {#getstmtinfo}

Stmt Information


> _input_ `::=` [`marker`](../../kernel/ast.md#marker) 
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"fct"` | _string_ | Function name |
| `"rank"` | _number_ | Global stmt order |


## plugins.eva.values.getProbeInfo (`GET`) {#getprobeinfo}

Probe informations


> _input_ `::=` [`marker`](../../kernel/ast.md#marker) 
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"evaluable"` | _boolean_ | Can the probe be evaluated? |
| `"code"` (opt.) | _string_ | Probe source code |
| `"stmt"` (opt.) | [`marker`](../../kernel/ast.md#marker)  | Probe statement |
| `"effects"` | _boolean_ | Effectfull statement |
| `"condition"` | _boolean_ | Conditional statement |


## plugins.eva.values.evaluation (`DATA`) {#evaluation}

Evaluation of an expression or lvalue


> [`evaluation`](#evaluation)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"value"` | _string_ | Textual representation of the value |
| `"alarms"` | `[` `"True"` | `"False"` | `"Unknown"` , _string_ `]` `[]` | Alarms raised by the evaluation |
| `"pointedVars"` | `[` _string_ , [`marker`](../../kernel/ast.md#marker)  `]` `[]` | List of variables pointed by the value |


## plugins.eva.values.getValues (`GET`) {#getvalues}

Abstract values for the given marker


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` `{` _output…_ `}`
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"target"` | [`marker`](../../kernel/ast.md#marker)  | Works with all markers containing an expression |
| `"callstack"` (opt.) | [`callstack`](values.md#callstack)  | Callstack to collect (defaults to none) |


| Output | Format | Description |
|:-------|:------:|:------------|
| `"vBefore"` (opt.) | [`evaluation`](values.md#evaluation)  | Domain values before execution |
| `"vAfter"` (opt.) | [`evaluation`](values.md#evaluation)  | Domain values after execution |
| `"vThen"` (opt.) | [`evaluation`](values.md#evaluation)  | Domain values for true condition |
| `"vElse"` (opt.) | [`evaluation`](values.md#evaluation)  | Domain values for false condition |
