---
title: WP Tactics
author:
date: 2024-06-06
...

# WP Tactics {#wp-tactics}

## plugins.wp.tac.kind (`DATA`) {#kind}

Parameter kind


> [`kind`](#kind)  `::=` `"checkbox"` | `"spinner"` | `"selector"` |
  `"browser"` | `"editor"`
  

## plugins.wp.tac.status (`DATA`) {#status}

Tactical status


> [`status`](#status)  `::=` `"NotApplicable"` | `"NotConfigured"` |
  `"Applicable"`
  

## plugins.wp.tac.value (`DATA`) {#value}

Parameter option value


> [`value`](#value)  `::=` `{` `"id"` `:` `$value` , `"label"` `:` _string_ ,
  `"title"` `:` _string_ `}`
  

## plugins.wp.tac.parameter (`DATA`) {#parameter}

Parameter configuration


> [`parameter`](#parameter)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"id"` | `$param` | Parameter identifier |
| `"kind"` | [`kind`](tac.md#kind)  | Parameter kind |
| `"label"` | _string_ | Short name |
| `"title"` | _string_ | Description |
| `"enabled"` | _boolean_ | Enabled parameter |
| `"value"` | _any_ | Value (with respect to kind) |
| `"vmin"` (opt.) | _number_ | Minimum range value (spinner only) |
| `"vmax"` (opt.) | _number_ | Maximum range value (spinner only) |
| `"vstep"` (opt.) | _number_ | Range step (spinner only) |
| `"vlist"` (opt.) | [`value`](tac.md#value)  `[]` | List of options (selector only) |


## plugins.wp.tac.tactical (`ARRAY`) {#tactical}

Tactical Configurations


## plugins.wp.tac.signalTactical (`SIGNAL`) {#signaltactical}

Signal for array [`tactical`](#tactical) 


## plugins.wp.tac.tacticalData (`DATA`) {#tacticaldata}

Data for array rows [`tactical`](#tactical) 


> [`tacticalData`](#tacticaldata)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"id"` | [`tactic`](tip.md#tactic)  | Entry identifier. |
| `"label"` | _string_ | Tactic name |
| `"title"` | _string_ | Tactic description |
| `"error"` (opt.) | _string_ | Tactic error |
| `"status"` | [`status`](tac.md#status)  | Tactic status |
| `"params"` | [`parameter`](tac.md#parameter)  `[]` | Configuration parameters |


## plugins.wp.tac.fetchTactical (`GET`) {#fetchtactical}

Data fetcher for array [`tactical`](#tactical) 


> _input_ `::=` _number_
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"reload"` | _boolean_ | array fully reloaded |
| `"removed"` | [`tactic`](tip.md#tactic)  `[]` | removed entries |
| `"updated"` | [`tacticalData`](tac.md#tacticaldata)  `[]` | updated entries |
| `"pending"` | _number_ | remaining entries to be fetched |


## plugins.wp.tac.reloadTactical (`GET`) {#reloadtactical}

Force full reload for array [`tactical`](#tactical) 


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  

## plugins.wp.tac.configureTactics (`EXEC`) {#configuretactics}

Configure all tactics


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` _null_
  

> _signals_
  

* `plugins.wp.tip.printStatus`


## plugins.wp.tac.setParameter (`EXEC`) {#setparameter}

Configure tactical parameter


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` _null_
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | [`node`](tip.md#node)  | Proof node target |
| `"tactic"` | [`tactic`](tip.md#tactic)  | Tactic to configure |
| `"param"` | `$param` | Parameter to configure |
| `"value"` | _any_ | New parameter value |


## plugins.wp.tac.applyTactic (`EXEC`) {#applytactic}

Applies the (configured) tactic


> _input_ `::=` [`tactic`](tip.md#tactic) 
  

> _output_ `::=` [`node`](tip.md#node)  `[]`
  

## plugins.wp.tac.applyTacticAndProve (`EXEC`) {#applytacticandprove}

Applies tactic and run provers on children


> _input_ `::=` [`tactic`](tip.md#tactic) 
  

> _output_ `::=` [`node`](tip.md#node)  `[]`
  